﻿using System;
using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Problems.Instances;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.PluginInfrastructure;

namespace HeuristicLab.Problems.MultiObjectiveTestFunctions {
  public class ZDTInstanceProvider : ProblemInstanceProvider<MOTFData> {

    public override string Name {
      get { return "ZDT"; }
    }

    public override string Description {
      get { return "ZDT Problems"; }
    }

    public override Uri WebLink {
      get { return new Uri("http://dev.heuristiclab.com/trac.fcgi/wiki/Documentation/Reference/Test%20Functions"); }
    }

    public override string ReferencePublication {
      get { return "http://www.tik.ee.ethz.ch/sop/download/supplementary/testproblems/"; }
    }

    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
      var evaluators = ApplicationManager.Manager.GetInstances<IMultiObjectiveTestFunction>()
                                                 .Where(x => x.Name.StartsWith(Name))
                                                 .OrderBy(x => x.Name);
      return evaluators.Select(x => new MOTFDataDescriptor(x));
    }

    public override MOTFData LoadData(IDataDescriptor id) {
      var descriptor = (MOTFDataDescriptor)id;
      return new MOTFData {
        Name = descriptor.Name,
        Description = descriptor.Description,
        Evaluator = descriptor.Evaluator
      };
    }
  }
}
